Package org.apache.lucene.queries.intervals

## Class IntervalQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.queries.intervals.IntervalQuery

-     public final class IntervalQuery
      extends Query

  A query that retrieves documents containing intervals returned from an `IntervalsSource`

  Static constructor functions for various different sources can be found in the `Intervals` class

  Scores for this query are computed as a function of the sloppy frequency of intervals appearing in a particular document. Sloppy frequency is calculated from the number of matching intervals, and their width, with wider intervals contributing lower values. The scores can be adjusted with two optional parameters:

  - pivot - the sloppy frequency value at which the overall score of the document will equal 0.5. The default value is 1
  - exp - higher values of this parameter make the function grow more slowly below the pivot and faster higher than the pivot. The default value is 1
  Optimal values for both pivot and exp depend on the type of queries and corpus of documents being queried.

  Scores are bounded to between 0 and 1. For higher contributions, wrap the query in a `BoostQuery`

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `IntervalQuery​(String field, IntervalsSource intervalsSource)` | Create a new IntervalQuery
    `IntervalQuery​(String field, IntervalsSource intervalsSource, float pivot)` | Create a new IntervalQuery with a scoring pivot
    `IntervalQuery​(String field, IntervalsSource intervalsSource, float pivot, float exp)` | Create a new IntervalQuery with a scoring pivot and exponent

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Weight` | `createWeight​(IndexSearcher searcher, ScoreMode scoreMode, float boost)` |
    `boolean` | `equals​(Object o)` |
    `String` | `getField()` | The field to query
    `int` | `hashCode()` |
    `String` | `toString​(String field)` |
    `void` | `visit​(QueryVisitor visitor)` |

    - ### Methods inherited from class org.apache.lucene.search.Query

      `classHash, rewrite, rewrite, sameClassAs, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### IntervalQuery

          public IntervalQuery​(String field,
                               IntervalsSource intervalsSource)

      Create a new IntervalQuery
      Parameters:
        `field` - the field to query
        `intervalsSource` - an `IntervalsSource` to retrieve intervals from

    - #### IntervalQuery

          public IntervalQuery​(String field,
                               IntervalsSource intervalsSource,
                               float pivot)

      Create a new IntervalQuery with a scoring pivot
      Parameters:
        `field` - the field to query
        `intervalsSource` - an `IntervalsSource` to retrieve intervals from
        `pivot` - the sloppy frequency value at which the score will be 0.5, must be within (0, +Infinity)

    - #### IntervalQuery

          public IntervalQuery​(String field,
                               IntervalsSource intervalsSource,
                               float pivot,
                               float exp)

      Create a new IntervalQuery with a scoring pivot and exponent
      Parameters:
        `field` - the field to query
        `intervalsSource` - an `IntervalsSource` to retrieve intervals from
        `pivot` - the sloppy frequency value at which the score will be 0.5, must be within (0, +Infinity)
        `exp` - exponent, higher values make the function grow slower before 'pivot' and faster after 'pivot', must be in (0, +Infinity)

  - ### Method Detail

    - #### getField

          public String getField()

      The field to query

    - #### toString

          public String toString​(String field)

      Specified by:
        `toString` in class `Query`

    - #### createWeight

          public Weight createWeight​(IndexSearcher searcher,
                                     ScoreMode scoreMode,
                                     float boost)
                              throws IOException

      Overrides:
        `createWeight` in class `Query`
      Throws:
        `IOException`

    - #### visit

          public void visit​(QueryVisitor visitor)

      Specified by:
        `visit` in class `Query`

    - #### equals

          public boolean equals​(Object o)

      Specified by:
        `equals` in class `Query`

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `Query`